float4x4 World;
float4x4 View;
float4x4 Projection;

sampler TextureSampler;

struct VS_INPUT {
	float4 Position : POSITION0;
	float2 Texcoord : TEXCOORD0;
};

struct VS_OUTPUT {
	float4 Position : POSITION0;
	float2 Texcoord : TEXCOORD0;
};

VS_OUTPUT Transform(VS_INPUT Input) {
	float4x4 WorldViewProjection = mul(mul(World, View), Projection);
	
	VS_OUTPUT Output;
	Output.Position = mul(Input.Position, WorldViewProjection);
	Output.Texcoord = Input.Texcoord;

	return Output;
}

struct PS_INPUT {
	float2 Texcoord : TEXCOORD0;
};

float4 BasicShader(PS_INPUT Input) : COLOR0 {
	return tex2D(TextureSampler, Input.Texcoord);
};

technique TransformTexture {
	pass P0 {
		VertexShader = compile vs_2_0 Transform();
		PixelShader  = compile ps_2_0 BasicShader();
	}
}