using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Evolution.Engine.SpatialTrees;
using Microsoft.Xna.Framework.Content;
using Evolution.Engine.Managers;

namespace Evolution.Engine.Interfaces
{
    public interface IHost
    {
        GameEngine Game { get; }
        GraphicsDeviceManager Graphics { get; }
        Scene Scene { get; }
        ContentManager Content { get; }
        InputManager Input { get; }

        // Here is where the script commands will be exposed, the main class implementing this interface will have to cater for all of these
        void WriteText(string text, int x, int y);
        void AddObject(BaseObject obj);
    }
}
