using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Evolution.Engine.Objects
{
    public class Light : BaseObject
    {
        private float _Power = 1.0f;
        private Vector4 _Specular = Vector4.Zero;
        private Vector4 _Diffuse = Vector4.Zero;
        private Vector4 _Ambient = Vector4.Zero;
        private LightType _Type = LightType.Diretional;
        private float _HoursInDay = 24f;

        public float HoursInDay { get { return _HoursInDay; } set { _HoursInDay = value; } }
        public LightType Type { get { return _Type; } set { _Type = value; } }
        public Vector4 Ambient { get { return _Ambient; } set { _Ambient = value; } }
        public Vector4 Diffuse { get { return _Diffuse; } set { _Diffuse = value; } }
        public Vector4 Specular { get { return _Specular; } set { _Specular = value; } }
        public float Power { get { return _Power; } set { _Power = value; } }

        public Light(string name)
            : base(name)
        {
        }
    }
}
